#include <stdio.h>

int main() {
    int N, M, flag=0, sum_temp, result=0;
    int arr[100];
    scanf("%d %d",&N, &M);
    for(int i=0; i<N; i++) {
        scanf("%d",arr+i);
    }

    for(int i=0; i<N; i++) {
        if(flag) break;
        for(int j=i+1; j<N; j++) {
            if(flag) break;
            for(int k=j+1; k<N; k++) {
                sum_temp = arr[i] + arr[j] + arr[k];
                if(sum_temp <= M) {
                    if(sum_temp > result) {
                        result = sum_temp;
                        if(result==M) {
                            flag = 1;
                            break;
                        }
                    }
                }
            }
        }
    }

    printf("%d\n",result);

    return 0;
}